import JavaFile = JVM.java$.io$.File;
import JavaBoolean = JVM.java$.lang$.Boolean;
import JavaFloat = JVM.java$.lang$.Float;
import JavaInteger = JVM.java$.lang$.Integer;
import JavaString = JVM.java$.lang$.String;
import StandardCharsets = JVM.java$.nio$.charset$.StandardCharsets;
import Files = JVM.java$.nio$.file$.Files;
import Paths = JVM.java$.nio$.file$.Paths;
import StandardOpenOption = JVM.java$.nio$.file$.StandardOpenOption;
import LiquidBounce = JVM.net$.ccbluex$.liquidbounce$.LiquidBounce;
import EventState = JVM.net$.ccbluex$.liquidbounce$.event$.EventState;
import MotionEvent = JVM.net$.ccbluex$.liquidbounce$.event$.MotionEvent;
import WorldEvent = JVM.net$.ccbluex$.liquidbounce$.event$.WorldEvent;
import MSTimer = JVM.net$.ccbluex$.liquidbounce$.utils$.timer$.MSTimer;
import BoolValue = JVM.net$.ccbluex$.liquidbounce$.value$.BoolValue;
import FloatValue = JVM.net$.ccbluex$.liquidbounce$.value$.FloatValue;
import IntegerValue = JVM.net$.ccbluex$.liquidbounce$.value$.IntegerValue;
import ListValue = JVM.net$.ccbluex$.liquidbounce$.value$.ListValue;
import TextValue = JVM.net$.ccbluex$.liquidbounce$.value$.TextValue;
import Value = JVM.net$.ccbluex$.liquidbounce$.value$.Value;
import GuiContainer = JVM.net$.minecraft$.client$.gui$.inventory$.GuiContainer;
import GuiInventory = JVM.net$.minecraft$.client$.gui$.inventory$.GuiInventory;
import GameSettings = JVM.net$.minecraft$.client$.settings$.GameSettings;
import KeyBinding = JVM.net$.minecraft$.client$.settings$.KeyBinding;
import MinecraftItem = JVM.net$.minecraft$.item$.Item;
import ItemAppleGold = JVM.net$.minecraft$.item$.ItemAppleGold;
import ItemFood = JVM.net$.minecraft$.item$.ItemFood;
import ItemSkull = JVM.net$.minecraft$.item$.ItemSkull;
import C03PacketPlayer = JVM.net$.minecraft$.network$.play$.client$.C03PacketPlayer;
import C07PacketPlayerDigging = JVM.net$.minecraft$.network$.play$.client$.C07PacketPlayerDigging;
import C08PacketPlayerBlockPlacement = JVM.net$.minecraft$.network$.play$.client$.C08PacketPlayerBlockPlacement;
import C09PacketHeldItemChange = JVM.net$.minecraft$.network$.play$.client$.C09PacketHeldItemChange;
import C0DPacketCloseWindow = JVM.net$.minecraft$.network$.play$.client$.C0DPacketCloseWindow;
import C16PacketClientStatus = JVM.net$.minecraft$.network$.play$.client$.C16PacketClientStatus;
import BlockPos = JVM.net$.minecraft$.util$.BlockPos;
import EnumFacing = JVM.net$.minecraft$.util$.EnumFacing;

var scriptName = "AutoEat";
var scriptVersion = 0.1;
var scriptAuthor = "mumy++";

class AutoEat {

    private readonly setting = {
        boolean: (name: string, value: boolean, extend: object = {}) => {
            return new _AdaptedValue<boolean, JavaBoolean>(new (Java.extend(BoolValue, extend))(name, value));
        },
        float: (name: string, value: number, minimum: number, maximum: number, extend: object = {}) => {
            return new _AdaptedValue<number, JavaFloat>(new (Java.extend(FloatValue, extend))(name, value, minimum, maximum));
        },
        integer: (name: string, value: number, minimum: number, maximum: number, extend: object = {}) => {
            return new _AdaptedValue<number, JavaInteger>(new (Java.extend(IntegerValue, extend))(name, value, minimum, maximum));
        },
        list: (name: string, values: string[], value: string, extend: object = {}) => {
            return new _AdaptedValue<string, JavaString>(new (Java.extend(ListValue, extend))(name, values, value));
        },
        text: (name: string, value: string, extend: object = {}) => {
            return new _AdaptedValue<string, JavaString>(new (Java.extend(TextValue, extend))(name, value));
        }
    };

    private readonly settings = {
        mode: this.setting.list("Mode", ["Use", "Packet"], "Packet"),
        delay: this.setting.integer("Delay", 250, 0, 5000),
        hurtTime: this.setting.integer("HurtTime", 0, 0, 20),
        health: this.setting.float("Health", 10, 0, 20),
        food: this.setting.float("Food", 19, 0, 20),
        buoy: this.setting.boolean("Buoy", false, {
            isSupported: () => this.settings.food.get() > 0
        }),
        inclusive: this.setting.boolean("Inclusive", false, {
            isSupported: () => this.settings.goldApple.get()
        }),
        absorption: this.setting.list("Absorption", ["Ignore", "Scale", "Strict"], "Strict", {
            isSupported: () => this.settings.health.get() > 0
        }),
        absorptionScale: this.setting.float("AbsorptionScale", 1, 0, 2, {
            isSupported: () => this.settings.health.get() > 0 && this.settings.absorption.get() === "Scale"
        }),
        efficiency: this.setting.boolean("Efficiency", true, {
            isSupported: () => this.settings.regularFood.get() && this.settings.food.get() > 0
        }),
        noInvEat: this.setting.boolean("NoInvEat", false),
        noAirEat: this.setting.boolean("NoAirEat", false),
        noMoveEat: this.setting.boolean("NoMoveEat", false),
        openInventory: this.setting.boolean("OpenInventory", false),
        simulateInventory: this.setting.boolean("SimulateInventory", false),
        inventoryItemDelay: this.setting.integer("InventoryItemDelay", 100, 0, 1000, {
            isSupported: () => this.settings.simulateInventory.get()
        }),
        skull: this.setting.boolean("Skull", false, {
            isSupported: () => this.settings.health.get() > 0
        }),
        goldApple: this.setting.boolean("GoldApple", true),
        regularFood: this.setting.boolean("RegularFood", false),
        customTherapeutic: this.setting.text("CustomTherapeutic", "", {
            isSupported: () => this.settings.health.get() > 0
        }),
        customFood: this.setting.text("CustomFood", "", {
            isSupported: () => this.settings.regularFood.get() && this.settings.food.get() > 0
        })
    };

    private readonly delayTimer = new MSTimer();
    private readonly inventoryItemTimer = new MSTimer();

    private readonly packetMode = new AutoEat.PacketMode(this);
    private readonly useMode = new AutoEat.UseMode(this);
    private readonly modeModuleMap = new Map<string, typeof AutoEat.ModeModule.prototype>([["Packet", this.packetMode], ["Use", this.useMode]]);

    private readonly valueContainer = new AutoEat.ValueContainer(this.settings);

    public getName() {
        return "AutoEat";
    }

    public getDescription() {
        return "AutoEat-Module, by-mumy";
    }

    public getCategory() {
        return "Misc";
    }

    public onEnable() {
        this.modeModuleMap.get(this.settings.mode.get())?.onEnable();
    }

    public onDisable() {
        this.modeModuleMap.get(this.settings.mode.get())?.onDisable();
    }

    public onUpdate() {
        this.modeModuleMap.get(this.settings.mode.get())?.onUpdate();
    }

    public onWorld(event: WorldEvent) {
        this.modeModuleMap.get(this.settings.mode.get())?.onWorld(event);
    }

    public addValues(values: _ValueAdapter) {
        for (let key of Object.keys(this.settings)) {
            values.add(this.settings[key as keyof typeof this.settings]);
        }
    }

    private cancelRun() {
        const player = mc.thePlayer!;
        return !this.delayTimer.hasTimePassed(this.settings.delay.get()) || !mc.playerController!.gameIsSurvivalOrAdventure() || player.hurtResistantTime < this.settings.hurtTime.get() || !player.onGround && this.settings.noAirEat.get() || mc.currentScreen instanceof GuiContainer && !(mc.currentScreen instanceof GuiInventory) || this.settings.noMoveEat.get() && (player.movementInput!.moveForward !== 0 || player.movementInput?.moveStrafe !== 0);
    }

    private healthSituation() {
        const player = mc.thePlayer!;
        const targetHealth = this.settings.health.get();
        const health = player.getHealth();
        if (!(health < targetHealth)) {
            return false;
        }
        const absorption = player.getAbsorptionAmount();
        switch (this.settings.absorption.get()) {
            case "Strict":
                return !(absorption > 0);
            case "Scale":
                return health + absorption * this.settings.absorptionScale.get() < targetHealth;
        }
        return true;
    }

    private foodSituation() {
        return mc.thePlayer!.getFoodStats()!.getFoodLevel() < this.settings.food.get();
    }

    private findAllItemSlot(startSlot: number, endSlot: number) {
        if (this.healthSituation()) {
            for (let find of [this.findSkullSlot, this.findGoloAppleSlot, (startSlot: number, endSlot: number) => this.findCustomItemSlot(startSlot, endSlot, this.settings.customTherapeutic.get())]) {
                const slot = find.call(this, startSlot, endSlot);
                if (slot !== -1) {
                    return slot;
                }
            }
        } else if (this.foodSituation()) {
            let slot = this.findFoodSlot(startSlot, endSlot);
            return slot !== -2 ? slot !== -1 ? slot : this.findCustomItemSlot(startSlot, endSlot, this.settings.customFood.get()) : -1;
        }
        return -1;
    }

    private findGoloAppleSlot(startSlot: number, endSlot: number) {
        if (!this.settings.goldApple.get()) {
            return -1;
        }
        return this.findItemSlot(startSlot, endSlot, (item) => item instanceof ItemAppleGold);
    }

    private findSkullSlot(startSlot: number, endSlot: number) {
        if (!this.settings.skull.get()) {
            return -1;
        }
        return this.findItemSlot(startSlot, endSlot, (item) => item instanceof ItemSkull);
    }

    private findFoodSlot(startSlot: number, endSlot: number) {
        if (!this.settings.regularFood.get()) {
            return -1;
        }
        const player = mc.thePlayer!;
        const inventoryContainer = player.inventoryContainer;
        if (inventoryContainer == null) {
            return -1;
        }
        const foodList: { slot: number, amount: number }[] = [];
        for (let slot = startSlot; slot < endSlot; ++slot) {
            const stack = inventoryContainer.getSlot(slot)?.getStack();
            const item = stack?.getItem();
            if (item instanceof ItemFood && !((!this.settings.inclusive.get() || !this.settings.goldApple.get()) && item instanceof ItemAppleGold)) {
                foodList.push({
                    slot,
                    amount: item.getHealAmount(stack)
                });
            }
        } if (foodList.length < 1) {
            return -1;
        }
        const targetAmount = (this.settings.buoy.get() ? this.settings.food.get() : 20) - player.getFoodStats()!.getFoodLevel();
        if (this.settings.efficiency.get()) {
            foodList.sort((a, b) => b.amount - a.amount);
        } else {
            foodList.sort((a, b) => a.amount - b.amount);
            if (foodList[0].amount > targetAmount) {
                return -2;
            }
        }
        foodList.sort((a, b) => Math.abs(a.amount - targetAmount) - Math.abs(b.amount - targetAmount));
        return foodList[0].slot;
    }

    private findCustomItemSlot(startSlot: number, endSlot: number, values: string) {
        const customTable = new Set(values.split(",").map((item) => parseInt(item)));
        if (customTable.size < 1) {
            return -1;
        }
        return this.findItemSlot(startSlot, endSlot, (item) => customTable.has(MinecraftItem.getIdFromItem(item)));
    }

    private findItemSlot(startSlot: number, endSlot: number, predicate: (item: MinecraftItem) => boolean) {
        const inventoryContainer = mc.thePlayer?.inventoryContainer;
        if (inventoryContainer == null) {
            return -1;
        } for (let slot = startSlot; slot < endSlot; ++slot) {
            const stack = inventoryContainer.getSlot(slot)?.getStack();
            const item = stack?.getItem();
            if (item != null && stack!.stackSize > 0 && predicate(item)) {
                return slot;
            }
        }
        return -1;
    }

    private findVoidSlot(startSlot: number, endSlot: number) {
        const inventoryContainer = mc.thePlayer?.inventoryContainer;
        if (inventoryContainer == null) {
            return -1;
        } for (let slot = startSlot; slot < endSlot; ++slot) {
            if (inventoryContainer.getSlot(slot)?.getStack() == null) {
                return slot;
            }
        }
        return -1;
    }

    private switchSlot(slot: number) {
        if (!this.inventoryItemTimer.hasTimePassed(this.settings.inventoryItemDelay.get())) {
            return;
        }
        const voidSlot = this.findVoidSlot(36, 45);
        if (voidSlot === -1) {
            return;
        }
        const openInventory = !(mc.currentScreen instanceof GuiInventory);
        if (openInventory) {
            if (this.settings.openInventory.get()) {
                return;
            }
            mc.getNetHandler()!.addToSendQueue(new C16PacketClientStatus(C16PacketClientStatus.EnumState.OPEN_INVENTORY_ACHIEVEMENT));
        }
        const player = mc.thePlayer!;
        const inventorySlot = player.inventoryContainer!.getSlot(slot)!;
        mc.playerController!.windowClick(player.inventoryContainer!.windowId, inventorySlot.slotNumber, voidSlot - 36, 2, player);
        if (openInventory) {
            mc.getNetHandler()!.addToSendQueue(new C0DPacketCloseWindow());
        }
        this.inventoryItemTimer.reset();
    }

    private static ModeModule = class ModeModule {

        public constructor(protected readonly module: AutoEat) {};

        public onEnable() {}
        public onDisable() {}
        public onUpdate() {}
        public onWorld(event: WorldEvent) {}

    }

    private static PacketMode = class PacketMode extends AutoEat.ModeModule {

        public onUpdate() {
            if (this.module.cancelRun()) {
                return;
            }
            const slot = this.module.findAllItemSlot(36, 45);
            if (slot === -1) {
                if (this.module.settings.simulateInventory.get()) {
                    const inventorySlot = this.module.findAllItemSlot(9, 36);
                    if (inventorySlot !== -1) {
                        this.module.switchSlot(inventorySlot);
                    }
                }
                return;
            } if (mc.currentScreen instanceof GuiInventory && this.module.settings.noInvEat.get()) {
                return;
            }
            const player = mc.thePlayer!;
            const onGround = player.onGround;
            const netHandler = mc.getNetHandler()!;
            netHandler.addToSendQueue(new C09PacketHeldItemChange(slot - 36));
            netHandler.addToSendQueue(new C08PacketPlayerBlockPlacement(player.inventoryContainer?.getSlot(slot)?.getStack()));
            for (let i = 0; i < 35; ++i) {
                netHandler.addToSendQueue(new C03PacketPlayer(onGround));
            }
            netHandler.addToSendQueue(new C07PacketPlayerDigging(C07PacketPlayerDigging.Action.RELEASE_USE_ITEM, BlockPos.ORIGIN, EnumFacing.DOWN));
            netHandler.addToSendQueue(new C09PacketHeldItemChange(player.inventory!.currentItem));
            this.module.delayTimer.reset();
        }

    }

    private static UseMode = class UseMode extends AutoEat.ModeModule {

        private eating = false;
        private itemSlot = -1;
        private originateItem = -1;
        private stackSize = -1;

        public onEnable() {
            this.reset();
            this.resetValues();
        }

        public onDisable() {
            this.onEnable();
        }

        public onUpdate() {
            const player = mc.thePlayer!;
            const inventory = player.inventory!;
            const slot = this.module.findAllItemSlot(36, 45);
            if (!this.eating) {
                if (this.module.cancelRun()) {
                    return;
                } if (slot === -1) {
                    if (this.module.settings.simulateInventory.get()) {
                        const inventorySlot = this.module.findAllItemSlot(9, 36);
                        if (inventorySlot !== -1) {
                            this.module.switchSlot(inventorySlot);
                        }
                    }
                    return;
                } if (mc.currentScreen instanceof GuiInventory && this.module.settings.noInvEat.get()) {
                    return;
                }
                this.updateStackSize(slot);
                this.originateItem = inventory.currentItem;
                inventory.currentItem = (this.itemSlot = slot) - 36;
                this.start();
            } else {
                if (slot === -1 || this.module.settings.noInvEat.get() && mc.currentScreen instanceof GuiInventory || inventory.currentItem !== this.itemSlot - 36 || this.stackSize > (player.inventoryContainer?.getSlot(slot)?.getStack()?.stackSize ?? this.stackSize - 1)) {
                    this.reset();
                    return;
                } if (slot !== this.itemSlot) {
                    inventory.currentItem = (this.itemSlot = slot) - 36;
                } if (!player.isUsingItem()) {
                    this.start();
                }
                this.updateStackSize(slot);
            }
        }

        public onWorld(event: WorldEvent) {
            this.onEnable();
        }

        private updateStackSize(slot: number) {
            this.stackSize = mc.thePlayer?.inventoryContainer?.getSlot(slot)?.getStack()?.stackSize ?? -1;
        }

        private start() {
            const player = mc.thePlayer!;
            mc.playerController!.sendUseItem(player, mc.theWorld, player.inventory!.getCurrentItem());
            KeyBinding.setKeyBindState(mc.gameSettings!.keyBindUseItem!.getKeyCode(), true);
            this.eating = true;
        }

        private stop() {
            mc.thePlayer!.stopUsingItem();
            KeyBinding.setKeyBindState(mc.gameSettings!.keyBindUseItem!.getKeyCode(), false);
            this.eating = false;
        }

        private reset() {
            const inventory = mc.thePlayer!.inventory!;
            if (!GameSettings.isKeyDown(mc.gameSettings!.keyBindUseItem)) {
                this.stop();
            } if (inventory.currentItem === this.itemSlot - 36) {
                inventory.currentItem = this.originateItem;
            }
            this.module.delayTimer.reset();
            this.eating = false;
        }

        private resetValues() {
            this.eating = false;
            this.itemSlot = -1;
            this.originateItem = -1;
            this.stackSize = -1;
        }

    }

    private static ValueContainer = class ValueContainer {

        private readonly directory = new JavaFile(LiquidBounce.fileManager!.dir, `scripts\\lib\\mumyScript\\${scriptName} ${scriptVersion}`);
        private readonly jsonFile = new JavaFile(this.directory, "values.json");
        private readonly defaultSettings!: object;

        public constructor(private settings: { [key: string]: _AdaptedValue<unknown, unknown> }) {
            this.defaultSettings = this.readSettings();
            settings.container = this.createContainerValue();
        }

        private createContainerValue() {
            return new _AdaptedValue<string, JavaString>(new (Java.extend(ListValue, {
                onChanged: (oldValue: string, newValue: string) => {
                    if (oldValue !== newValue) {
                        this.writeContainer(oldValue, this.readSettings());
                        this.writeSettings(this.readContainer(newValue));
                    }
                }
            }))("Container", ["C0", "C1", "C2"], "C0"));
        }

        private check() {
            if (!this.directory.exists() || !this.directory.isDirectory()) {
                this.directory.mkdirs();
            } if (!this.jsonFile.exists() || !this.jsonFile.isFile()) {
                this.jsonFile.createNewFile();
            }
        }

        private readSettings() {
            const object: any = {};
            for (let key of Object.keys(this.settings)) {
                if (key === "container") {
                    continue;
                }
                object[key] = this.settings[key].get();
            }
            return object;
        }

        private writeSettings(object: object, save: boolean = false) {
            const mothod = save ? "set" : "changeValue";
            for (let key of Object.keys(object)) {
                if (key === "container") {
                    continue;
                }
                const value = this.settings[key]?.getValue();
                if (value == null) {
                    continue;
                }
                const set = object[key as keyof typeof object];
                try {
                    if (value instanceof BoolValue) {
                        value[mothod](JavaBoolean.valueOf(set) as JavaBoolean);
                    } else if (value instanceof FloatValue) {
                        value[mothod](JavaFloat.valueOf(set) as JavaFloat);
                    } else if (value instanceof IntegerValue) {
                        value[mothod](JavaInteger.valueOf(set) as JavaInteger);
                    } else if (value instanceof ListValue) {
                        value[mothod](JavaString.valueOf(set) as JavaString);
                    } else if (value instanceof TextValue) {
                        value[mothod](JavaString.valueOf(set) as JavaString);
                    }
                } catch (error) {}
            } if (!save) {
                this.writeSettings(object, true);
            }
        }

        private readContainer(name: string) {
            const object = this.readJSONObject();
            return object[name] ?? this.defaultSettings;
        }

        private writeContainer(name: string, object: object) {
            const jsonObject = this.readJSONObject();
            jsonObject[name] = object;
            this.writeJSONObject(jsonObject);
        }

        private readJSONObject() {
            this.check();
            try {
                return JSON.parse(new JavaString(Files.readAllBytes(Paths.get(this.jsonFile.toURI())), StandardCharsets.UTF_8) as any as string);
            } catch (error) {
                return {};
            }
        }

        private writeJSONObject(object: object) {
            this.check();
            try {
                Files.write(Paths.get(this.jsonFile.toURI()), new JavaString(JSON.stringify(this.sortObjectKeys(object), null, 4)).getBytes(StandardCharsets.UTF_8), StandardOpenOption.CREATE, StandardOpenOption.WRITE, StandardOpenOption.TRUNCATE_EXISTING);
            } catch (error) {}
        }

        private sortObjectKeys(object: object) {
            const newObject: any = {};
            for (let key of Object.keys(object).sort()) {
                newObject[key] = object[key as keyof typeof object];
            }
            return newObject;
        }

    }

}

let scriptInstance: any;

function onLoad() {}

function onEnable() {
    scriptInstance = moduleManager.registerModule(new AutoEat());
}

function onDisable() {
    moduleManager.unregisterModule(scriptInstance);
}